/* C base for the startuproutine to be located at addr 0. */
/* Verilog version.  This does not assume anything about what is in
   registers at startup, does not do any simulator calls (except 28 as
   a special case to exit) and ends in an eternal loop.
    Nothing else is changed, but the interrupt routines probably dont
   apply.

     This is probably more the one fit to a real system.
   */

#define STACK_LEN 10000  /* Enough? */

/* You should not use this in the simulator (But it works). */
static unsigned char stack[STACK_LEN+2] __attribute__ ((aligned (2)));

#include <stdio.h>

/* Nothing should depend on this in the real system. */
#include "simcodes.h"

/* See crt0.c for doc on these. */
#undef asm
extern int _Filenos;
extern FILE _Files[];
char *_Environ;
char **_Argv;
int _Argc;
void _start(void);
static int _Exit_stat=0;
static long tmp = S_simcycles;
size_t _Atcount = 32;
extern const char _Do_interrupt;
void (*_Atfuns[32])(void);
void start(void)
{
  __asm__ volatile(".word 43");	/* Configuration word. Magic for rsim. */
  __asm__ volatile ("clear.w [0xe0000000]"); /* Set 0 waitstates. */
  __asm__ volatile ("ba startstart");
  __asm__ volatile ("nop
Here_is_int_4_vector:");
  __asm__ volatile(".dword int2");	/* Odd/Even mix as MG wanted to test it. */
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");

  /* 32..39 are the only vectors used in etrax. */
__asm__ volatile("\nHere_is_int_0x20_vector:");
  __asm__ volatile(".dword int32");
  __asm__ volatile(".dword int33");
  __asm__ volatile(".dword int34");
  __asm__ volatile(".dword int35");
  __asm__ volatile(".dword int36");
  __asm__ volatile(".dword int37");
  __asm__ volatile(".dword int38");
  __asm__ volatile(".dword int39");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__  volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile(".dword int2");
  __asm__ volatile(".dword int3");
  __asm__ volatile("
startstart:");
  /* Initialize some registers */
  __asm__ volatile("move 0,ccr");	/* No flags set. */

  /* Initialize stack. */
  __asm__ volatile("move.d %0,sp" :: "g" (stack+STACK_LEN));

  /* stdin, stdout and stderr set to NULL. */
  __asm__ volatile("clear.d r10");
  __asm__ volatile("clear.d r11");
  __asm__ volatile("clear.d r12");

  /* Give absolutely nonsense values for argc, argv and env. */
  __asm__ volatile("moveq -1,r0");
  __asm__ volatile("moveq -1,r1");
  __asm__ volatile("moveq -1,r2");
  __asm__ volatile("jump __start");
       
}

/* The rest is almost the same as in crt0.c */
void _start(void)
{
  int i;

  /** All is setup in the simulator:

   * Reasonable stack for sp
     (very important; so we can split this file into routines!) 

   * Argument counter to r10

   * Argument vector to r11

   * Environment to r12

   * stdin, stdout, stderr in r0,r1,r2

   Remember to check the assembler output so it has not clobbered
    crucial registers, or ANYTHING.

   */
  __asm__ volatile("move.d r0,[__Files]");
  __asm__ volatile("move.d r1,[__Files+4]");
  __asm__ volatile("move.d r2,[__Files+8]");
  __asm__ volatile("move.d r10,[__Argc]"); 
  __asm__ volatile("move.d r11,[__Argv]");
  __asm__ volatile("move.d r12,[__Environ]");
#if 0
  for (i = 3; i < 32; i++)
    _Files[i] = 0;
#endif
  _Filenos = 0;

  /*   __asm__ volatile("move.d sp,__Old_sp"); */
  main(_Argc,_Argv,_Environ);

  __asm__ volatile(".global __exit\n__exit:\n\tmove.d r10,[__Exit_stat]");
  /*   __asm__ volatile("move.d __Old_sp,sp");x */

  /*
  for (i = 3; i < 32; i++)
    if (_Files[i])
      fclose(_Files+i);
*/

  __asm__ volatile
    ("
	move.d [__Exit_stat],r10
	.global __Exit
__Exit:
	move.d [_tmp],r11
	bmod [r11],r10 ; According to MG/PZ this is a nop in the real thing.
___Ex:
        ba ___Ex  ; Infinite loop if the real thing.
        nop
");

}

void _cleanup(void) {
  int i = 32;
  
  while (i > _Atcount)
    (_Atfuns[--i])();
}

/* Avoid ctor/dtor stuff from libgcc.a */
void __main(void) {}
