/*
 * varargs.h cannot be portable...
 *
 */
#ifndef __CRIS__
#error This varargs.h is for gcc on the CRIS processor ONLY!
#else

#ifndef _VARARGS_H
#define _VARARGS_H

#define va_list __va___list
#ifndef ___list
#define ___list
typedef void * __va___list;
#endif
#define va_alist __builtin_va_alist
/* Note that this will expand:
    foo(va_list)
       va_dcl;
    { stuff(); }
   into:
    foo(__builtin_va_alist)
       int __builtin_va_alist; ...
    { stuff(); }
   which isnt EXACTLY conforming to
   ANSI-C (you twit!)
*/
#define va_dcl int __builtin_va_alist; ...
/* Do all varargs/stdarg stuff here, and just #include this
   with _STDARG_H #defined from stdarg.h
*/

#ifdef _STDARG_H
# if (__GNUC__ >= 2) && (__GNUC_MINOR__ >= 6)
#  define va_start(AP, LASTARG)					\
  (AP = ((void *) __builtin_next_arg (LASTARG)))
# else
#  define va_start(AP, LASTARG)					\
  (AP = ((LASTARG),(void *) __builtin_next_arg ()))
# endif
#else
#define va_start(AP) 						\
 ((AP) = ((void *) &__builtin_va_alist))
#endif
#define va_end(list)

#define va_arg(list,TYPE) \
  __extension__ \
  ({ TYPE __va_temp;\
     /* Parameters larger than 32 bits are passed via reference. \
        Other parameters are passed with a FIXED SIZE of 32 bits, \
        i.e. they are promoted to int, or null-filled. */ \
     (sizeof(__va_temp) > sizeof(long)) \
       ? (__va_temp = **((TYPE **) (list))) \
	 : (__va_temp = *((TYPE *) (list))); ((long *) (list))++; \
   __va_temp;}) \

#endif /* !cris */
#endif
